PROGRAM GrafData;

uses crt;

VAR
    piecedata: String[7];
    Fname: String[20];
    datafile: TEXT;
    tdata: ARRAY[1..640] OF real;
    maxt,mint,ranget,deltay:real;
    deltax,tickx,ticky,x,y: integer;
    j,totemp,terr,interval: Integer;
    minutes : Boolean;
    ch : Char;

procedure setvideo(md:word); assembler; asm
  mov ax,md; int 10h; end;

procedure putpixel(x,y:word; c:byte);
var b:byte;
begin
  port[$3c4]:=2; port[$3c5]:=c;
  b:=mem[$a000:y*80+x shr 3];
  mem[$a000:y*80+x shr 3]:=b or (1 shl (7-(x and 7)));
end;

procedure line(x1, y1, x2, y2, color:integer);
var
    d, x, y, sx, sy, dx, dy:integer;
begin
    {
        dx, dy = distance, d = deviation,
        sx, sy = sign of distance.
    }

    dx := x2 - x1; dy := y2 - y1;
    if dx > 0 then sx := 1 else sx := -1;
    if dy > 0 then sy := 1 else sy := -1;
    dx := abs(dx); dy := abs(dy);
    x := x1; y := y1;

    if dx > dy then begin
        d := (dy - dx) div 2;       { X is major axis }
        while x <> x2 do begin
            putpixel(x, y, color);  { Put pixel }
            if d >= 0 then begin    { Minor-axis change? }
                dec(d, dx);         { Decrease by 1 }
                inc(y, sy);
            end;
            inc(d, dy);             { Increase by dy/dx }
            inc(x, sx);
        end;
        putpixel(x, y, color);      { Put last pixel }
    end else begin
        d := (dx - dy) div 2;       { Y is major axis }
        while y <> y2 do begin
            putpixel(x, y, color);  { Put pixel }
            if d >= 0 then begin    { Minor-axis change? }
                dec(d, dy);         { Decrease by 1 }
                inc(x, sx);
            end;
            inc(d, dx);             { Increase by dx/dy }
            inc(y, sy);
        end;
        putpixel(x, y, color);      { Put last pixel }
    end;
end;

PROCEDURE OutTextXY(x,y:Byte;len:word); assembler;
ASM
  mov ah, $13
  mov al, 1
  mov bl, $F
  mov bh, 0
  mov cx, len
  mov dl, x
  mov dh, y
  mov bp, seg piecedata
  mov es, bp
  mov bp, offset piecedata
  inc bp
  int $10
END;

BEGIN
  Clrscr;
  Writeln('***** Display graph of data one piece per line *****');
  Writeln;
  Write('Input Filename: ');
  Readln(fname);
  Assign(datafile,fname);
  {$i-} Reset(datafile); {$i+}
  IF IOResult <> 0 THEN BEGIN
    Writeln('Can''t open '+fname);
    Halt;
  END;
  Write('Interval in minutes, (not seconds), y/n?');
  Readln(ch);
  IF UpCase(ch) = 'Y' then minutes := TRUE ELSE minutes := FALSE;
  IF minutes THEN  Write('Minutes between data points: ') ELSE
                   Write('Seconds between data points: ');
  Readln(interval);
   j := 1;
  WHILE NOT EOF(datafile) DO
    BEGIN
       Readln(datafile,piecedata);
       Val(piecedata,tdata[j],terr);
       IF terr <> 0 THEN writeln('Error in data',j);
       Inc(j);
    END;
  totemp := j-1;
  maxt := tdata[1]; mint := maxt;
  FOR j := 2 TO totemp DO
      BEGIN
        IF tdata[j] > maxt THEN maxt := tdata[j];
        IF tdata[j] < mint THEN mint := tdata[j];
      END;
  ranget := maxt - mint + 0.2 * (maxt-mint);
  IF ranget < 1 THEN ranget := 1;
  setvideo($12);
  line(39,0,639,0,$F);
  line(39,423,639,423,$F);
  line(39,0,39,423,$F);
  line(639,0,639,423,$F);

  deltax := 600 DIV totemp;
  deltay := 424/ranget;
  tickx := totemp DIV 8;
  IF tickx = 0 THEN tickx := 1;
  IF totemp > 10 THEN WHILE tickx MOD 5 <> 0 DO Inc(tickx);
  IF totemp > 30 THEN WHILE tickx MOD 10 <> 0 DO Inc(tickx);
  ticky := Round(ranget) DIV 8;
  IF ticky = 0 THEN ticky := 1;
  IF ranget > 10 THEN WHILE ticky MOD 5 <> 0 DO Inc(ticky);
  IF ranget > 30 THEN WHILE ticky MOD 10 <> 0 DO Inc(ticky);

  j:= 0;
  WHILE j*deltax+ 20 < 620 DO
    BEGIN
       x := j*deltax; 
       IF j MOD tickx = 0 THEN BEGIN
               line(x+39,423,x+39,440,$F);
               Str(j*interval,piecedata);
               OutTextXY((x+39) DIV 8 ,27,length(piecedata)); 
          END;
       Inc(j);
    END;
  IF minutes THEN piecedata := 'minutes' ELSE  piecedata := 'seconds';
  OutTextXY(35,28,7);
  j := 0;
  WHILE j*deltay+ 24 < 424 DO
    BEGIN
       y := 424 - j* Round(deltay); 
       IF (j + Round(mint)) MOD ticky = 0 THEN BEGIN
               line(10,y,39,y,$F);
               Str(j+Round(mint),piecedata);
               OutTextXY(0,y DIV 17,length(piecedata)); 
           END;
       Inc(j);
    END;
  FOR j:= 1 TO Pred(totemp) DO
   BEGIN
    Line(39+deltax*(j-1),423-Round((tdata[j]-mint)*deltay),
         39+deltax*(j),423-Round((tdata[j+1]-mint)*deltay),$F);
    Line(38+deltax*(j-1),423-Round((tdata[j]-mint)*deltay),
         38+deltax*(j),423-Round((tdata[j+1]-mint)*deltay),$F);
     Line(39+deltax*(j-1),424-Round((tdata[j]-mint)*deltay),
         39+deltax*(j),424-Round((tdata[j+1]-mint)*deltay),$F);
    END;
  WHILE NOT KeyPressed do;
  setvideo(3);
end. 
